﻿// Upgrade NOTE: replaced 'mul(UNITY_MATRIX_MVP,*)' with 'UnityObjectToClipPos(*)'

Shader "PixelLiner/Normal" 
{
	Properties { 
		_MainTex ("Texture", any) = "" {} 
        _Color("Color",Color) = (1.0, 1.0, 1.0, 1.0)
		 [Enum(Off, 0, On, 1)]
		_ZWrite("ZWrite",Float) =1
        [MaterialToggle] PixelSnap ("Pixel snap", Float) = 1
	} 

	SubShader {

		Tags { "RenderType"="Transparent" "Queue"="Transparent" } 
		
		Lighting Off 
		Blend SrcAlpha OneMinusSrcAlpha, One One  
		//Cull Off 
		ZWrite [_ZWrite] 
		Fog { Mode Off } 
		ZTest Always 
		
		Pass {	
			CGPROGRAM
			#pragma vertex vert
			#pragma fragment frag

			#include "UnityCG.cginc"

			struct appdata_t {
				half4 vertex : POSITION;
				fixed4 color : COLOR;
				half2 texcoord : TEXCOORD0;
			};

			struct v2f {
				half4 vertex : SV_POSITION;
				fixed4 color : COLOR;
				half2 texcoord : TEXCOORD0;
			};

			sampler2D _MainTex;
			fixed4 _Color;

			uniform half4 _MainTex_ST;
			
			v2f vert (appdata_t v)
			{
				v2f o;
				o.vertex = UnityObjectToClipPos(v.vertex);
				o.color = v.color*_Color ;
				o.texcoord = TRANSFORM_TEX(v.texcoord,_MainTex);
                o.vertex = UnityPixelSnap (o.vertex);
				return o;
			}

			fixed4 frag (v2f i) : SV_Target
			{
				return tex2D(_MainTex, i.texcoord) * i.color;
			}
			ENDCG 
		}
	} 
	
	Fallback off 
}