﻿using System.Collections;
using System.Collections.Generic;

#if UNITY_EDITOR
using UnityEditor;
#endif
using UnityEngine;

namespace PixelLiner.PixelLinerLib {
    public class BasicAnimator : MonoBehaviour {
        public string firstAnimName;

        protected int width;
        protected int height;
        // int bodyx = 0;
        // int bodyy = 0;
        // int shiftx = 0;
        // int shifty = 0;

        protected int maisu = 0;
        protected int loop_to = 0;
        protected int loop_count = 0;

        protected bool stopped = true;
        float keika60 = 0;
        int changed = 0; //アニメーションが切り替わるとtrue。isChanged()で取得すること。
        protected int cframe_ = 0; // getAfでビットマップを取得すると保存される。

        protected bool cframe_is_looped = false;
        protected int shiftloopafter60 = 0; // ループ部分が使用する時間
        public bool auto_update_animation = true; // 描画時に自動で updateAnimator を実行。
        public bool multiply_global_timescale = true; // updateAnimator の速度に timeScale を乗算する
        protected string[] Aframe_snd;

        // Use this for initialization
        void Awake () {
            if (Aframe_snd == null) Aframe_snd = new string[maisu];
        }
        // Update is called once per frame
        protected virtual void Update () {
            if (auto_update_animation) updateAnimator ();
        }
        //
        public void copyValuesTo (BasicAnimator destE, bool copy_anim_data = false) {
            // destE.width = width;
            // destE.height = height;
            // destE.bodyx = bodyx;
            // destE.bodyy = bodyy;
            // destE.shiftx = shiftx;
            // destE.shifty = shifty;
            destE.maisu = maisu;
            destE.loop_to = loop_to;
            destE.auto_update_animation = auto_update_animation;
            if (copy_anim_data) {
                calculateFrameSpeed ();
                destE.motionSetFrom (this);
            }
        }
        // ======================================================== 
        // MARK: animation 
        // ========================================================
        public void calculateFrameSpeed () {
            int endf60 = 0;
            loop_to = X.Mn (maisu - 1, loop_to);
            if (Aframe_snd != null) System.Array.Resize (ref Aframe_snd, maisu);
            for (var i = 0; i < this.maisu; i++) {
                endf60 += getAf (i);
                setEndAf (i, endf60);
            }
            fineShiftLoop ();
        }
        public void setLoopFrame (int val) {
            this.calculateFrameSpeed ();
            this.loop_to = X.Mn (this.maisu - 1, val);
            fineShiftLoop ();
        }
        public void fineShiftLoop (int set_val = -1) {
            this.shiftloopafter60 = set_val < 0 ? getEndAf (this.maisu - 1) - getEndAf (this.loop_to - 1) : set_val;
        }

        // 要 override
        protected virtual int getAf (int i) { // フレーム単独の表示時間取得
            return 1;
        }
        protected virtual int getEndAf (int i) { // フレーム単独の表示時間取得
            if (i < 0) return 0;
            return 1;
        }
        protected virtual void setAf (int i, int _f) { // そのフレームの累計表示時間取得

        }
        protected virtual void setEndAf (int i, int _f) { // そのフレームの累計表示時間取得

        }
        public int getDuration () {
            return getEndAf (this.maisu - 1);
        }
        public void extendDuration (int dur60) {
            float lvl = dur60 / getEndAf (this.maisu - 1);
            for (int i = 0; i < maisu; i++) {
                setAf (i, (int) Mathf.Round (getAf (i) * lvl));
                setEndAf (i, (int) Mathf.Round (getEndAf (i) * lvl));
            }
            this.keika60 = Mathf.Round (this.keika60 * lvl);
            this.shiftloopafter60 = (int) Mathf.Round (this.shiftloopafter60 * lvl);
        }
        public bool updateAnimator (float time_scale = 1) {
            bool ret = false;
            bool sndflag = false;
            changed = 0;
            if (maisu == 0) return false;
            if (multiply_global_timescale) time_scale *= Time.timeScale;
            if (stopped) {
                stopped = false;
                changed++;
                ret = true;
                sndflag = true;
            } else {
                keika60 += time_scale;
                cframe_is_looped = false;
                //int i = cframe;
                while (keika60 >= getEndAf (cframe_)) {
                    changed++;
                    if (cframe_ >= maisu - 1) {
                        int p_cframe = cframe_;
                        loop_count++;
                        keika60 -= shiftloopafter60 != 0 ? shiftloopafter60 : getEndAf (cframe_);
                        cframe_ = loop_to;
                        cframe_is_looped = true;
                        if (cframe_ != p_cframe) ret = true;

                    } else {
                        cframe_++;
                        sndflag = ret = true;
                    }
                }
            }

            if (sndflag) {
                //redraw();
                if (Aframe_snd != null && Aframe_snd[cframe_] != null) {
                    //SND.play(Aframe_snd[cframe]);
                }
            }
            // サウンド再生とか。
            return ret;
        }
        public bool isChanged () {
            return changed > 0;
        }
        public bool isAnimEnd () {
            return this.loop_count > 0 ? true : false;
        }
        public bool isAnimInLooping () {
            return (this.loop_to <= 0 || this.keika60 >= getDuration ()) ? true : false;
        }
        public int get_loop_count () {
            return loop_count;
        }
        public int getCurrentFrame () {
            return cframe_;
        }
        public int getLoopBackFrame () {
            return loop_to;
        }
        public int countTotalFrame () {
            return maisu;
        }
        public int cframe {
            get { return cframe_; }
        }
        public void animReset (int set_frame = 0) {
            this.loop_count = 0;
            this.cframe_ = (int) X.MMX (0, set_frame, maisu - 1);
            this.keika60 = (this.cframe_ <= 0 ? 0 : getEndAf (this.cframe_ - 1));
            stopped = true;
            changed = 0;
            cframe_is_looped = false;
        }
        public void motionSetFrom (BasicAnimator _A) {
            this.loop_count = 0;
            keika60 = _A.keika60;
            stopped = _A.stopped;
            cframe_ = 0;
            bool pre_stopped = stopped;
            updateAnimator (0);
            if (pre_stopped) updateAnimator (0);
            changed = 0;
            cframe_is_looped = false;
        }
        public virtual void destruct () {
            // Apt = null;
            Aframe_snd = null;
        }

    }

#if UNITY_EDITOR
    [CustomEditor (typeof (BasicAnimator))]
    public class BasicAnimatorEditor : Editor {
        public override void OnInspectorGUI () {
            var EF = target as BasicAnimator;

            EF.firstAnimName =
                EditorGUILayout.TextField ("First Anim Title", EF.firstAnimName);
        }
    }
#endif
}