/* basic lib */
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
// using ByteArray=PixelLiner.PixelLinerLib.ByteArray;
namespace PixelLiner.PixelLinerLib {
    public class X {
        public static readonly float PI = 3.14159265358979323846f;

        public const float TAN_22_5 = 0.41421356237f;
        public const float TAN_67_5 = 2.41421356237f;
        public static float Nm (string num, float isNaNdefault = 0.0f, bool emptyDefault = false) {
            // emptyDefault:: num===""ならisNanDefaultを返す
            if (num == "" && emptyDefault) {
                return isNaNdefault;
            }
            if (num == null) return isNaNdefault;
            float f = float.Parse (num);
            return float.IsNaN (f) ? isNaNdefault : f;
        }

        public static bool BTW (int num1, int hensu, int num2) {
            return ((num1) <= (hensu) && (hensu) < (num2)) ? true : false;
        }
        public static bool BTW (float num1, float hensu, float num2) {
            return ((num1) <= (hensu) && (hensu) < (num2)) ? true : false;
        }
        public static bool BTWM (float num1, float hensu, float num2) {
            return ((num1) < (hensu) && (hensu) <= (num2)) ? true : false;
        }
        public static float Mx (float v1, float v2) {
            return (((v1) < (v2)) ? (v2) : (v1));
        }
        public static float Mn (float v1, float v2) {
            return (((v1) > (v2)) ? (v2) : (v1));
        }
        public static ulong Mx (ulong v1, ulong v2) {
            return (((v1) < (v2)) ? (v2) : (v1));
        }

        public static int Mx (int v1, int v2) {
            return (((v1) < (v2)) ? (v2) : (v1));
        }
        public static int Mn (int v1, int v2) {
            return (((v1) > (v2)) ? (v2) : (v1));
        }
        public static float Abs (float v1) {
            return v1 > 0 ? v1 : -v1;
        }

        public static int MPF (float num) {
            return num != 0 ? (1) : -1;
        }
        public static int MPF (bool num) {
            return num ? (1) : -1;
        }
        public static int MPF (int num) {
            return num != 0 ? (1) : -1;
        }
        public static int MMX (int minnum, int thenum, int maxnum) {
            return (Mx (minnum, Mn (thenum, maxnum)));
        }
        public static bool isCovering (float l1, float r1, float l2, float r2, float expand = 0) {
            // 重なっている 矩形判定で使用
            if (expand != 0) {
                float c = (l1 + r1) / 2;
                l1 = X.Mn (l1 - expand, c);
                r1 = X.Mx (r1 + expand, c);
            }
            if ((r1 - l1) < (r2 - l2)) {
                float b = l1;
                l1 = l2;
                l2 = b;
                b = r1;
                r1 = r2;
                r2 = b;
            }
            return BTW (l1, l2, r1) || BTWM (l1, r2, r1);
        }
        public static bool isContaining (float l1, float r1, float l2, float r2, float expand = 0) {
            // 左側が完全に右を内包している 矩形判定で使用
            if (expand != 0) {
                float c = (l1 + r1) / 2;
                l1 = X.Mn (l1 - expand, c);
                r1 = X.Mx (r1 + expand, c);
            }
            return BTW (l1, l2, r1) && BTWM (l1, r2, r1);
        }
        public static T[] subtract<T> (T[] A, int src_index, int cnt) {
            T[] Aret = new T[cnt];
            System.Array.Copy (A, src_index, Aret, 0, cnt);
            return Aret;
        }
        public static T[] subtract<T> (T[] A, int src_index) {
            return subtract (A, src_index, A.Length - src_index);
        }
        public static void shiftEmpty<T> (T[] A, int count = 1, int first = 0) where T : class {
            // 配列の大きさは変えない
            int ARMX = A.Length;
            int th = ARMX - count;
            int exp = count + 1;
            for (int i = count + first; i < ARMX; i++) {
                T Item = A[i];
                A[i - count] = Item;
                if (Item == null && --exp <= 0) return;
            }
            for (int i = th; i < ARMX; i++) A[i] = null;
        }
        public static void pushA<T> (ref T[] A, T[] AItem) {
            int ARMXj = AItem.Length;
            int i = 0;
            if (A == null) {
                A = new T[ARMXj];
            } else {
                i = A.Length;
                System.Array.Resize (ref A, i + ARMXj);
            }
            for (int j = 0; j < ARMXj; j++) {
                A[i + j] = AItem[j];
            }
        }
        public static T[] objKeys<T, T2> (Dictionary<T, T2> O) {
            T[] Aret = new T[O.Count];
            int i = 0;
            foreach (KeyValuePair<T, T2> _kvp in O) {
                //string _k = kvp.Key;
                //THETYPE _val = kvp.Value;
                Aret[i++] = _kvp.Key;
            }
            return Aret;
        }
    }
}