﻿using System.Collections;
using System.Collections.Generic;
using PixelLiner.PixelLinerLib;
using UnityEngine;
/*
ゲーム用スプライトファイル作成
スプライトを BLF パッキングした1枚の画像
 */
namespace PixelLiner {
    public class PxlsImgAtlasUv {
        uint id;
        double id2;
        public int x;
        public int y;
        public int width;
        public int height;
        public int extend_pixel = 0;

        public PxlsImgAtlasUv (uint _id, double _id2) {
            id = _id;
            id2 = _id2;
        }
        public string key {
            get { return "EDI" + id.ToString ("x") + "_" + id2.ToString (); }
        }
        public int w {
            get {
                return width;
            }
            set {
                width = value;
            }

        }
        public int h {
            get {
                return height;
            }
            set {
                height = value;
            }
        }
        public int right {
            get { return x + width; }
        }
        public int bottom {
            get { return y + height; }
        }
        public bool isin (int _px, int _py) {
            return X.BTW (x - extend_pixel, _px, x + width + extend_pixel) && X.BTW (y - extend_pixel, _py, y + height + extend_pixel);
        }

        public bool isCovering (PxlsImgAtlasUv D, float _extend = 0) {
            // 少しでも重なっている
            return X.isCovering (x, right, D.x, D.right, _extend) && X.isCovering (y, bottom, D.y, D.bottom, _extend);
        }

        public bool isContaining (PxlsImgAtlasUv D, float _extend = 0) {
            // Dを内包している
            return X.isContaining (x, right, D.x, D.right, _extend) && X.isContaining (y, bottom, D.y, D.bottom, _extend);
        }

    }
}